/**
 * crc16.h
 *
 * Author: Christian Jung <chris@tapage.de>
 * Date  : 2009-06-06
 */


#ifndef _CRC16_H
#define _CRC16_H

#include <string.h>
#include <inttypes.h>

extern uint16_t crc16_table[256];

/**
 * Compute the CRC from the given CRC and the next byte of a stream.
 */
static inline uint16_t crc16_byte( const uint16_t crc, const uint8_t data ) {
	return (crc << 8) ^ crc16_table[ ((crc >> 8) ^ data) & 0xff ];
}

void crc16_init_table( const uint16_t polynom );
uint16_t crc16_init( const uint16_t init );
uint16_t crc16( const uint16_t init, uint8_t const *buffer, size_t length );

#endif /* _CRC16_H */
